var aubPrefsVar = {

init: function() {
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
    var count = aubPrefsVar.getIntegerPreferenceValue("iterator", prefs, 3);
    var parent = document.getElementById("rows");
    var children;
    var isParent;
    var newParent;
    var parentStack = new Array();
    var countStack = new Array();
    var childCounter = count;
    var stackPointer = 0;

    document.documentElement.getButton("accept").hidden = false;
    document.getElementById("openPref").selectedIndex = aubPrefsVar.getIntegerPreferenceValue("open", prefs, 1);
    document.getElementById("variable").value = aubPrefsVar.getCharacterPreferenceValue("variable", prefs, "");

    for (var i = 1; i <= count; i++) {
        children = aubPrefsVar.getIntegerPreferenceValue("children"+i, prefs);
        isParent = (children > 0);
        newParent = aubPrefsVar.addTreeItem(parent, aubPrefsVar.getCharacterPreferenceValue("name"+i, prefs, "Unknown"), aubPrefsVar.getCharacterPreferenceValue("url"+i, prefs, "Unknown"), isParent);
        childCounter--;
        if (isParent) {
            parentStack[stackPointer] = parent;
            countStack[stackPointer] = childCounter;
            parent = newParent;
            childCounter = children;
            stackPointer++;
        }
        while (childCounter == 0 && stackPointer > 0) {
            stackPointer--;
            parent = parentStack[stackPointer];
            childCounter = countStack[stackPointer];
        }
    }
},

addTreeItem: function(parent, name, url, folder) {
    var tempItem;
    var tempRow;
    var newParent;

    tempItem = document.createElement("treeitem");

    if (folder) {
        tempItem.setAttribute("container", "true");
        tempItem.setAttribute("open", "true");
        newParent = document.createElement("treechildren");
        tempItem.appendChild(newParent);
    }

    parent.appendChild(tempItem);
    tempRow = document.createElement("treerow");
    tempItem.appendChild(tempRow);

    tempItem = document.createElement("treecell");
    tempItem.setAttribute("label", name);
    tempRow.appendChild(tempItem);

    tempItem = document.createElement("treecell");
    tempItem.setAttribute("label", url);
    tempRow.appendChild(tempItem);

    return newParent;
},

addItem: function() {
    aubPrefsVar.addTreeItem(aubPrefsVar.findParent(), "New Item", "http://"+document.getElementById("variable").value, false);
},

addFolder: function() {
    aubPrefsVar.addTreeItem(aubPrefsVar.findParent(), "New Folder", "", true);
},

findParent: function() {
    var tree = aubPrefsVar.getTree();
    var index = tree.currentIndex;
    var parent = document.getElementById("rows");
    if (index != -1) {
        var item = tree.view.getItemAtIndex(index);
        if (item.getAttribute("container") == "true") {
            item.setAttribute("open", "true");
            parent = item.firstChild;
        }
    }
    return parent;
},

deleteItem: function(folderSelectedMessage) {
    var tree = aubPrefsVar.getTree();
    var item = tree.view.getItemAtIndex(tree.currentIndex);
    var flag = true;
    if (item.getAttribute("container") == "true") {
        flag = confirm(folderSelectedMessage);
    }
    if (flag) {
        item.parentNode.removeChild(item);
    }
},

moveItem: function(direction, nothingSelectedMessage) {
    var tree = aubPrefsVar.getTree();
    var index = tree.currentIndex;
    if (index == -1) {
        alert(nothingSelectedMessage);
    } else {
        var item = tree.view.getItemAtIndex(index);
        if (direction == "up") {
            if (item.previousSibling) {
                item.parentNode.insertBefore(item, item.previousSibling)
                tree.view.selection.select(index - 1)
            }
        } else {
            if (item.nextSibling) {
                item.parentNode.insertBefore(item.nextSibling, item)
                tree.view.selection.select(index + 1)
            }
        }
    }
},

getCharacterPreferenceValue: function(fieldName, prefs, defaultValue) {
	var tmp;

	if (prefs.getPrefType("aub."+fieldName) == prefs.PREF_STRING) {
		tmp = prefs.getCharPref("aub."+fieldName);
	} else {
		tmp = defaultValue;
	}

	return tmp;
},

getIntegerPreferenceValue: function(fieldName, prefs, defaultValue) {
	var tmp;

	if (prefs.getPrefType("aub."+fieldName) == prefs.PREF_INT) {
		tmp = prefs.getIntPref("aub."+fieldName);
	} else {
		tmp = defaultValue;
	}

	return tmp;
},

accept: function() {
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
    var tree = aubPrefsVar.getTree();
    var count = tree.view.rowCount;
    var j;
    var children;

    // remove the flag so that the menu will be rebuilt next time it's opened
    var menuItem = window.opener.document.getElementById("context-aub");
    if (menuItem) {
        menuItem.setAttribute("flags", "");
    }

    aubPrefsVar.saveIntField("open", document.getElementById("openPref").selectedIndex, prefs);
    aubPrefsVar.saveField("variable", document.getElementById("variable").value, prefs);

    if (count > 0) {
        aubPrefsVar.saveIntField("iterator", count, prefs);

        for (var i = 0; i < count; i++) {
            j = i + 1;
            children = 0;
            aubPrefsVar.saveField("name"+j, tree.view.getCellText(i, tree.columns["nameColumn"]), prefs);
            aubPrefsVar.saveField("url"+j, tree.view.getCellText(i, tree.columns["urlColumn"]), prefs);
            if (tree.view.isContainer(i)) {
                children = tree.view.getItemAtIndex(i).firstChild.childNodes.length;
            }
            aubPrefsVar.saveIntField("children"+j, children, prefs);
        }
    }
},

saveField: function(fieldName, newValue, prefs) {
	prefs.setCharPref("aub."+fieldName, newValue);
},

saveIntField: function(fieldName, newValue, prefs) {
	prefs.setIntPref("aub."+fieldName, newValue);
},

getTree: function() {
    return document.getElementById("treeThing");
}
};
